/*	ENCODER - 1 BYTE   62  (    1 - 0,06 ms)
	      .
           ,   
            ( =PINx.n,  =PINx.n+1)
         (PINx)-@0   (0-7)-@1.
        SRAM   _Count (1 byte)
*/
; -  
.equ G0=0b00			
.equ G1=0b10
.equ G2=0b11
.equ G3=0b01

;   
.def Mask = r16
.def Before = r17	; 
.def Actual = r18	; 	
.def Temp0 = r19	;  0
.def Temp1 = r20	;  1
.def Temp2 = r21	;  2

		.dseg
_Before:	.byte 1 	; 
_Count:	.byte 2	;  SRAM

		.CSEG
.MACRO  Encod_2
			;@0 -     (PINx)
			;@1 -          B  (B=A+1)
	in Actual,@0		;  
	ldi Mask,3<<@1	;    
	and Actual,Mask	;   
	ldi Mask,@1
	cpi mask,0	;  mask      
	breq pc+4	;     
	lsr Actual	;    
	dec mask	; 
	rjmp pc-4	;   
	;  Actual     . 
	lds Before,_before
	rcall F1	;   
	sts _Before,Actual
.ENDM
rjmp _END	; 
;_____________________(F1)________________________________________________________________________________
F1:
		;    G0
	ldi temp0,G0
	cpse actual,temp0	;  -  . 
	rjmp pc+2
	rcall _G0
	;    G1
	ldi temp0,G1
	cpse actual,temp0
	rjmp PC+2
	rcall _G1
	;    G2
	ldi temp0,G2
	cpse actual,temp0
	rjmp PC+2
	rcall _G2
	;    G3
	ldi temp0,G3
	cpse actual,temp0
	rjmp PC+2
	rcall _G3
ret

;___________________(G0)___________________________________________________________________________________
_G0:	
	lds before,_Before
	cpi before,G1
	brne PC+2
	rcall _add1
	cpi before,G3
	brne PC+2
	rcall _sub1
ret
;__________________(G1)____________________________________________________________________________________
_G1:
	lds before,_Before
	cpi before,G0
	brne PC+2
	rcall _sub1
	cpi before,G2
	brne PC+2
	rcall _add1
ret
;_________________(G2)______________________________________________________________________________________
_G2:
	lds Before,_Before
	cpi before,G1
	brne PC+2
	rcall _sub1
	cpi before,G3
	brne PC+2
	rcall _add1
ret
;________________(G3)_______________________________________________________________________________________
_G3:
	lds Before,_Before
	cpi before,G0
	brne PC+2
	rcall _add1
	cpi before,G2
	brne PC+2
	rcall _sub1
ret
;=================(_ADD1)===================================================================================
;  _count
_add1:
	lds Temp0,_count
	lds Temp1,_count+1
	ser temp2
	cp Temp0,temp2
	cpc Temp1,temp2	
	breq m0	
	subi temp0,(-1)
	sbci temp1,(-1)
	sts _count,temp0
	sts _count+1,temp1
m0: ret
;  _out

_sub1:
	lds Temp0,_count
	lds Temp1,_count+1
	clr temp2
	cp  Temp0,temp2
	cpc Temp1,temp2	
	breq m1
	subi temp0,1
	sbci temp1,0	
	sts _count,temp0
	sts _count+1,temp1
m1: ret
;========================================================================================================
_END:









