/*
.......................................................................................................
		ENCODER - 2 BYTE ( - ENCOD_2  @0,@1,@2,@3)
.......................................................................................................
	      .
           ,   
            ( =PINx.n,  =PINx.n+1)
         (PINx)-@0      (0-7) - @1.
        SRAM   _Count (2 byte)
      _Before (1 Byte,       ) -
        .DSEG -  @2.     _ounter - @3. 
             ,   _Before.
           ,       R16  
     R21 .    
            ,     
       - :

*/
/*
             G0    G1    G2    G3

         G0   -    -1         +1	

         G1  +1     -    -1     

         G2       +1    -     -1

         G3  -1         +1     -

     -  -     
     +1 - 
     -1 - 
       -   (      .
              
     http://club.shelek.ru/viewart.php?id=369#post_A1
*/
;______________  -  ________________________________________________________________
.equ G0=0b00			
.equ G1=0b10
.equ G2=0b11
.equ G3=0b01

;______________   _______________________________________________________________________
;          .
.def Mask = r16	;       
.def Loop = r16	;  

.def Before = r17	; 
.def Actual = r18	; 	
.def Temp0 = r19	;  0
.def Temp1 = r20	;  1
.def Temp2 = r21	;  2



		.CSEG
.MACRO  Encod_2
			;@0 -     (PINx)
			;@1 -          B  (B=A+1)
			;@2 - _Before (    _Before0 - _BeforeN)SRAM
			;@3 - _Coun (2-     _Count0 - _CountN)SRAM
	in Actual,@0	  ;  
	and Actual,Mask ;   
	ldi Loop,@1
	cpi Loop,0	  ;  Loop      
	breq pc+4	  ;     
	lsr Actual	  ;    
	dec Loop	  ; 
	rjmp pc-4	  ;   
	;  Actual     . 
	lds Before,@2   ;   Before   
	rcall F1	;   
	sts @2,Actual
rjmp end
;______________	ldi Mask,3<<@1  ;    
_______(F1)________________________________________________________________________________
F1:
		;    G0
	ldi temp0,G0
	cpse actual,temp0	;  -  . 
	rjmp pc+2
	rcall _G0
	;    G1
	ldi temp0,G1
	cpse actual,temp0
	rjmp PC+2
	rcall _G1
	;    G2
	ldi temp0,G2
	cpse actual,temp0
	rjmp PC+2
	rcall _G2
	;    G3
	ldi temp0,G3
	cpse actual,temp0
	rjmp PC+2
	rcall _G3
ret
 before,G1 
	brne PC+2	;    
	rcall 
;___________________   (G0)___________________________________________________________________________________
_G0:   	
	lds before,@2
	cpi_add1	;G1,   
	cpi before,G3	;      
	brne PC+2	;G3,   
	rcall _sub1
ret
;__________________   (G1)____________________________________________________________________________________
_G1:
	lds before,@2 ; G0,   
	cpi before,G0
	brne PC+2
	rcall _sub1
	cpi before,G2
	brne PC+2
	rcall _add1
ret
;_________________(G2)______________________________________________________________________________________
_G2:
	lds Before,@2
	cpi before,G1
	brne PC+2
	rcall _sub1
	cpi before,G3
	brne PC+2
	rcall _add1
ret
;________________(G3)_______________________________________________________________________________________
_G3:
	lds Before,@2
	cpi before,G0
	brne PC+2
	rcall _add1
	cpi before,G2
	brne PC+2
	rcall _sub1
ret
;=================(_ADD1)===================================================================================
;  _count
_add1:
	lds Temp0,@3
	lds Temp1,@3+1
	ser temp2
	cp Temp0,temp2
	cpc Temp1,temp2	
	breq m0	
	subi temp0,(-1)
	sbci temp1,(-1)
	sts @3,temp0
	sts @3+1,temp1
m0: 
ret
;  _out

_sub1:
	lds Temp0,@3
	lds Temp1,@3+1
	clr temp2
	cp  Temp0,temp2
	cpc Temp1,temp2	
	breq m1
	subi temp0,1
	sbci temp1,0	
	sts @3,temp0
	sts @3+1,temp1
m1: 
ret

end:	nop
.ENDM
;========================================================================================================










